#ifndef STRUCTS_H
#define STRUCTS_H

#include "DataType.h"

typedef struct {
    const char* name;
    DataType type;
} StructVariable;

typedef struct {
    const char* name;
    int id;
    int amount;
    StructVariable* vars;
} Struct;

typedef struct {
    int capacity;
    int entries;
    Struct* data;
} Structs;

void stAddVariable(Struct* st, const char* name, DataType type);

void stsInit(Structs* sts);
void stsDelete(Structs* sts);
Struct* stsSearch(Structs* sts, const char* name);
Struct* stsAdd(Structs* sts, const char* name);

#endif